; This file is automaticaly generated. Do not edit!

; *** Literal Code ***


(define (token-type-to-arity token)
  (case token
    ((postfix-typeop prefix-typeop postfix-op prefix-op postfix-jct prefix-jct)
     1)
    ((prod-typeop tensor-typeop sum-typeop binding-op add-op mul-op exp-op
      rel-op and-op or-op imp-op pair-op and-jct or-jct tensor-jct imp-jct)
     2)
    (else 0)))

(define (alg-name-to-token-value alg-name)
  (let ((token-type (alg-name-to-token-type alg-name)))
    (case (token-type-to-arity token-type)
      ((0) alg-name)
      ((1) (lambda (x) (make-alg alg-name x)))
      ((2) (lambda (x y) (make-alg alg-name x y)))
      (else (myerror "unexpected arity" token-type)))))

(define (const-to-token-value const)
  (let ((token-type (const-to-token-type const)))
    (case (token-type-to-arity token-type)
      ((0) (make-term-in-const-form const))
      ((1) (lambda (x) 
	     (make-term-in-app-form 
	      (make-term-in-const-form const) x)))
      ((2) (lambda (x y) 
	     (make-term-in-app-form 
	      (make-term-in-app-form 
	       (make-term-in-const-form const) x) y)))
      (else (myerror "unexpected arity" token-type)))))

; added 01-07-14
(define (const-and-token-type-to-token-value const token-type)
  (case (token-type-to-arity token-type)
    ((0) (make-term-in-const-form const))
    ((1) (lambda (x) 
	   (make-term-in-app-form 
	    (make-term-in-const-form const) x)))
    ((2) (lambda (x y) 
	   (make-term-in-app-form 
	    (make-term-in-app-form 
	     (make-term-in-const-form const) x) y)))
    (else (myerror "unexpected arity" token-type))))

(define (token-type-to-precedence token-type)
  (case token-type
    ((binding-op bindterm) 1)
    ((pair-op term) 2)
    ((imp-op impterm) 3)
    ((or-op orterm) 4)
    ((and-op andterm) 5)
    ((rel-op relterm) 6)
    ((add-op addterm) 7)
    ((mul-op multerm) 8)
    ((exp-op expterm) 9)
    ((appterm) 10)
    ((prefix-op preterm) 11)
    ((postfix-op postterm) 12)
    ((const var number rec-op if-op atomic-term) 13)
    (else (myerror
	   "token-type-to-precendence: token type expected" token-type))))

(define (left-assoc? token-type)
  (memq token-type
	'(add-op addterm mul-op multerm exp-op expterm and-op andterm or-op orterm appterm)))
			    
(define (right-assoc? token-type)
  (memq token-type '(pair-op term imp-op impterm)))

(define (type-var-name-to-type type-var-name)
  (if (eq? (car type-var-name) #f)
      (myerror "Unknown variable name " (cdr type-var-name))
      (car type-var-name)))

(define (type-var-name-to-name type-var-name)
  (cdr type-var-name))

(define (pt string)
  (let ((t (pf string)))
    (if (eq? (car t) 'atom)
	(cadr t)
	(myerror "pt: term expected" t))))

(define (py string)
  (let ((t (pt string)))
    (if (eq? (car t) 'term-in-var-form)
	(cadr t)
	(myerror "py: type expected" t))))

(define (pv string)
  (let ((t (pt string)))
    (if (eq? (car t) 'term-in-var-form)
	(term-in-var-form-to-var t)
	(myerror "pv: variable expected" t))))

; *** Token Definitions ***
(define token-nrs
  (list 
   (cons '*eoi* 0)
   (cons 'number 1)
   (cons 'var-index 2)
   (cons 'tvar-name 3)
   (cons 'tconst 4)
   (cons 'var-name 5)
   (cons 'const 6)
   (cons 'pvar-name 7)
   (cons 'pvar-op 8)
   (cons 'pred-infix 9)
   (cons 'predconst-name 10)
   (cons 'idpredconst-name 11)
   (cons 'idpredconstscheme-name 12)
   (cons 'idpredconstscheme-name-wit 13)
   (cons 'type-symbol 14)
   (cons 'alg 15)
   (cons 'constscheme 16)
   (cons 'alg-typeop 17)
   (cons 'postfix-typeop 18)
   (cons 'prefix-typeop 19)
   (cons 'prod-typeop 20)
   (cons 'tensor-typeop 21)
   (cons 'sum-typeop 22)
   (cons 'arrow 23)
   (cons 'postfix-op 24)
   (cons 'prefix-op 25)
   (cons 'rec-op 26)
   (cons 'binding-op 27)
   (cons 'add-op 28)
   (cons 'mul-op 29)
   (cons 'exp-op 30)
   (cons 'rel-op 31)
   (cons 'and-op 32)
   (cons 'or-op 33)
   (cons 'imp-op 34)
   (cons 'pair-op 35)
   (cons 'pairscheme-op 36)
   (cons 'cterm-op 37)
   (cons 'if-op 38)
   (cons 'postfix-jct 39)
   (cons 'prefix-jct 40)
   (cons 'and-jct 41)
   (cons 'or-jct 42)
   (cons 'tensor-jct 43)
   (cons 'imp-jct 44)
   (cons 'quantor 45)
   (cons 'dot 46)
   (cons 'hat 47)
   (cons 'underscore 48)
   (cons 'comma 49)
   (cons 'semicolon 50)
   (cons 'prime 51)
   (cons 'hatprime 52)
   (cons 'hatprimeunderscore 53)
   (cons 'hatunderscore 54)
   (cons 'primeunderscore 55)
   (cons 'lpar 56)
   (cons 'rpar 57)
   (cons 'lbracket 58)
   (cons 'rbracket 59)
   (cons 'lcurl 60)
   (cons 'rcurl 61)
   (cons 'undefined-token 62)
   (cons 'string 63)
   (cons 'mpc-mpc 64)
   (cons 'mpc-proof 65)
   (cons 'mpc-classic 66)
   (cons 'mpc-intuitionistic 67)
   (cons 'mpc-end 68)
   (cons 'mpc-load 69)
   (cons 'mpc-include 70)
   (cons 'mpc-scheme 71)
   (cons 'mpc-type 72)
   (cons 'mpc-pred 73)
   (cons 'mpc-algebra 74)
   (cons 'mpc-function 75)
   (cons 'mpc-partial 76)
   (cons 'mpc-rewrite 77)
   (cons 'mpc-syntax 78)
   (cons 'mpc-op 79)
  ))

(define token-defs
  (vector 
 "*eoi*"
 "number"
 "var-index"
 "tvar-name"
 "tconst"
 "var-name"
 "const"
 "pvar-name"
 "pvar-op"
 "pred-infix"
 "predconst-name"
 "idpredconst-name"
 "idpredconstscheme-name"
 "idpredconstscheme-name-wit"
 "type-symbol"
 "alg"
 "constscheme"
 "alg-typeop"
 "postfix-typeop"
 "prefix-typeop"
 "prod-typeop"
 "tensor-typeop"
 "sum-typeop"
 "arrow"
 "postfix-op"
 "prefix-op"
 "rec-op"
 "binding-op"
 "add-op"
 "mul-op"
 "exp-op"
 "rel-op"
 "and-op"
 "or-op"
 "imp-op"
 "pair-op"
 "pairscheme-op"
 "cterm-op"
 "if-op"
 "postfix-jct"
 "prefix-jct"
 "and-jct"
 "or-jct"
 "tensor-jct"
 "imp-jct"
 "quantor"
 "dot"
 "hat"
 "underscore"
 "comma"
 "semicolon"
 "prime"
 "hatprime"
 "hatprimeunderscore"
 "hatunderscore"
 "primeunderscore"
 "lpar"
 "rpar"
 "lbracket"
 "rbracket"
 "lcurl"
 "rcurl"
 "undefined-token"
 "string"
 "mpc-mpc"
 "mpc-proof"
 "mpc-classic"
 "mpc-intuitionistic"
 "mpc-end"
 "mpc-load"
 "mpc-include"
 "mpc-scheme"
 "mpc-type"
 "mpc-pred"
 "mpc-algebra"
 "mpc-function"
 "mpc-partial"
 "mpc-rewrite"
 "mpc-syntax"
 "mpc-op"
  ))

; *** Action Table ***
(define action-table
  '#(
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2) (64 . 1))
     ((default . *error*) (50 . 62))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (38 . 64) (56 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 71) (10 . 12) (11 . 11) (12 . 70) (13 . 69) (15 . 10) (16 . 68) (17 . 9) (19 . 8) (25 . 7) (26 . 67) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (56 . 80) (58 . 79))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (19 . 8) (56 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (56 . 63))
     ((default . -122))
     ((default . -34))
     ((default . -34) (2 . 86) (48 . 85))
     ((default . -82))
     ((default . -44) (2 . 95) (47 . 94) (48 . 93) (51 . 92) (52 . 91) (53 . 90) (54 . 89) (55 . 88))
     ((default . -156))
     ((default . -86) (2 . 98) (47 . 97) (48 . 96))
     ((default . -121))
     ((default . -126) (2 . 99))
     ((default . -158))
     ((default . -3))
     ((default . -154))
     ((default . -152) (24 . 100))
     ((default . -150))
     ((default . -148))
     ((default . -146) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 101) (56 . 80) (58 . 79))
     ((default . -144) (30 . 103))
     ((default . -142) (29 . 104))
     ((default . -140) (28 . 106) (31 . 105))
     ((default . -138))
     ((default . -136) (32 . 107))
     ((default . -134) (33 . 109) (34 . 108))
     ((default . -132) (35 . 111) (36 . 110))
     ((default . -32) (9 . 113))
     ((default . -120))
     ((default . -119))
     ((default . -117) (18 . 114))
     ((default . -113))
     ((default . -112) (3 . 18) (4 . 17) (15 . 10) (56 . 63))
     ((default . -109) (20 . 116))
     ((default . -107) (21 . 117))
     ((default . -105) (22 . 119) (23 . 118))
     ((default . -92) (2 . 122) (47 . 121) (48 . 120))
     ((default . -157))
     ((default . -60) (2 . 130) (47 . 129) (48 . 128) (51 . 127) (52 . 126) (53 . 125) (54 . 124) (55 . 123))
     ((default . -34))
     ((default . -34))
     ((default . -31))
     ((default . -30))
     ((default . -27))
     ((default . -25) (39 . 133))
     ((default . -17))
     ((default . -19))
     ((default . -15))
     ((default . -13) (41 . 134))
     ((default . -11))
     ((default . -9) (42 . 136) (43 . 135))
     ((default . -6))
     ((default . -7) (44 . 137))
     ((default . -4))
     ((default . -2))
     ((default . *error*) (0 . 138))
     ((default . -167))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (56 . 80) (58 . 79))
     ((default . -85) (49 . 143))
     ((default . *error*) (59 . 144))
     ((default . *error*) (1 . 145) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 149))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . -82) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . -32) (9 . 113) (57 . 155))
     ((default . -92) (2 . 122) (47 . 121) (48 . 120) (57 . 156))
     ((default . *error*) (57 . 157))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (46 . 158) (56 . 3) (58 . 2))
     ((default . -24))
     ((default . -22))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (46 . 161) (56 . 80) (58 . 79))
     ((default . *error*) (38 . 64))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (16 . 68) (17 . 9) (19 . 8) (25 . 7) (26 . 67) (27 . 6) (56 . 80) (58 . 2))
     ((default . -151))
     ((default . -116))
     ((default . -115))
     ((default . -40) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (56 . 80) (58 . 79))
     ((default . -34) (2 . 165))
     ((default . -34))
     ((default . -36) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (56 . 80) (58 . 79))
     ((default . -55) (2 . 168))
     ((default . -56) (2 . 169))
     ((default . -59) (2 . 170))
     ((default . -53) (2 . 171))
     ((default . -50) (2 . 172))
     ((default . -49) (2 . 173))
     ((default . -47) (2 . 174))
     ((default . -45))
     ((default . -91) (2 . 175))
     ((default . -89) (2 . 176))
     ((default . -87))
     ((default . -127))
     ((default . -153))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . -147))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 101) (56 . 80) (58 . 79))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 101) (56 . 80) (58 . 79))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 101) (56 . 80) (58 . 79))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 101) (56 . 80) (58 . 79))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 101) (56 . 80) (58 . 79))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 101) (56 . 80) (58 . 79))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 101) (56 . 80) (58 . 79))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (56 . 80) (58 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (56 . 80) (58 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (56 . 80) (58 . 2))
     ((default . -118))
     ((default . -114))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . -97) (2 . 195) (5 . 194))
     ((default . -95) (2 . 196))
     ((default . -93))
     ((default . -71) (2 . 197))
     ((default . -72) (2 . 198))
     ((default . -75) (2 . 199))
     ((default . -68) (2 . 200))
     ((default . -66) (2 . 201))
     ((default . -65) (2 . 202))
     ((default . -63) (2 . 203))
     ((default . -61))
     ((default . -28) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (56 . 80) (58 . 79))
     ((default . -41) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (56 . 80) (58 . 79))
     ((default . -26))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2))
     ((default . -1) (0 . accept))
     ((default . -166) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2) (60 . 224) (65 . 223) (66 . 222) (67 . 221) (68 . 220) (69 . 219) (70 . 218) (71 . 217) (72 . 216) (73 . 215) (74 . 214) (75 . 213) (76 . 212) (78 . 211) (50 . -182))
     ((default . *error*) (57 . 156))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (56 . 80) (58 . 79) (59 . 236))
     ((default . -163))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (56 . 80) (58 . 2))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63) (57 . 241))
     ((default . -124))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63) (57 . 243))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (37 . 244) (56 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 149))
     ((default . *error*) (56 . 247) (57 . 246))
     ((default . -80))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 149) (57 . 249))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63) (57 . 251))
     ((default . -155))
     ((default . -123))
     ((default . -33))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2))
     ((default . -23))
     ((default . -21))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (56 . 80) (58 . 2))
     ((default . -149))
     ((default . *error*) (57 . 155))
     ((default . -35))
     ((default . -34))
     ((default . -39) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (56 . 80) (58 . 79))
     ((default . -37) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (56 . 80) (58 . 79))
     ((default . -54))
     ((default . -57))
     ((default . -58))
     ((default . -52))
     ((default . -51))
     ((default . -48))
     ((default . -46))
     ((default . -90))
     ((default . -88))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (56 . 80) (58 . 79))
     ((default . -145) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 101) (56 . 80) (58 . 79))
     ((default . -143) (30 . 103))
     ((default . -139) (28 . 106))
     ((default . -141) (29 . 104))
     ((default . -137))
     ((default . -133))
     ((default . -135) (32 . 107))
     ((default . -165) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . -128))
     ((default . -129))
     ((default . -29))
     ((default . -111))
     ((default . -110) (3 . 18) (4 . 17) (15 . 10) (56 . 63))
     ((default . -108) (20 . 116))
     ((default . -104))
     ((default . -106) (21 . 117))
     ((default . -98) (2 . 257) (47 . 256) (48 . 255))
     ((default . -96))
     ((default . -94))
     ((default . -70))
     ((default . -73))
     ((default . -74))
     ((default . -69))
     ((default . -67))
     ((default . -64))
     ((default . -62))
     ((default . -16))
     ((default . -18))
     ((default . -10))
     ((default . -8))
     ((default . -14))
     ((default . -12) (41 . 134))
     ((default . -5))
     ((default . *error*) (24 . 267) (25 . 266) (28 . 265) (29 . 264) (31 . 263) (32 . 262) (33 . 261) (34 . 260) (35 . 259) (62 . 258))
     ((default . *error*) (75 . 269))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (62 . 271))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (46 . 273) (56 . 63))
     ((default . *error*) (46 . 275))
     ((default . *error*) (63 . 276))
     ((default . *error*) (63 . 277))
     ((default . *error*) (63 . 278))
     ((default . -181))
     ((default . *error*) (65 . 279))
     ((default . *error*) (65 . 280))
     ((default . -178))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2))
     ((default . *error*) (50 . 283))
     ((default . -197) (60 . 284))
     ((default . *error*) (60 . 286))
     ((default . *error*) (50 . 287))
     ((default . -172))
     ((default . *error*) (46 . 288))
     ((default . *error*) (50 . 289))
     ((default . *error*) (50 . 290))
     ((default . -168))
     ((default . -92) (2 . 122) (47 . 121) (48 . 120) (46 . 291))
     ((default . -183) (46 . -184))
     ((default . -162))
     ((default . -164))
     ((default . -84))
     ((default . -131))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63) (57 . 292))
     ((default . -159))
     ((default . -125))
     ((default . -161))
     ((default . *error*) (56 . 293))
     ((default . *error*) (56 . 247) (57 . 294))
     ((default . -42))
     ((default . *error*) (37 . 244))
     ((default . -81))
     ((default . -77))
     ((default . *error*) (56 . 247) (57 . 295))
     ((default . -83))
     ((default . -20))
     ((default . -130))
     ((default . -38) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (56 . 80) (58 . 79))
     ((default . -103) (2 . 296))
     ((default . -101) (2 . 297))
     ((default . -99))
     ((default . -215))
     ((default . -216))
     ((default . -217))
     ((default . -218))
     ((default . -219))
     ((default . -220))
     ((default . -222))
     ((default . -221))
     ((default . -223))
     ((default . -224))
     ((default . *error*) (79 . 298))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (46 . 300))
     ((default . -202) (62 . 271))
     ((default . -201) (1 . 302))
     ((default . *error*) (62 . 271))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (46 . 304) (56 . 63))
     ((default . *error*) (62 . 271))
     ((default . -177))
     ((default . -176))
     ((default . -175))
     ((default . -180))
     ((default . -179))
     ((default . -182) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2) (60 . 224))
     ((default . *error*) (46 . 310))
     ((default . -174))
     ((default . -198))
     ((default . -209))
     ((default . -204) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . -173))
     ((default . -170))
     ((default . -171))
     ((default . -169))
     ((default . *error*) (62 . 271))
     ((default . -160))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (56 . 63) (57 . 316))
     ((default . -43))
     ((default . -76))
     ((default . -102))
     ((default . -100))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (56 . 80) (58 . 2))
     ((default . *error*) (46 . 319))
     ((default . *error*) (62 . 320))
     ((default . -203))
     ((default . -200))
     ((default . -194))
     ((default . *error*) (62 . 271))
     ((default . -191))
     ((default . -182) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2) (60 . 224) (61 . 322))
     ((default . -188))
     ((default . *error*) (50 . 325))
     ((default . -183))
     ((default . -186))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (56 . 80) (58 . 2) (61 . 327) (77 . 326) (78 . 211))
     ((default . -204) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (61 . 333))
     ((default . *error*) (46 . 334))
     ((default . -192))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2))
     ((default . *error*) (57 . 336))
     ((default . -214))
     ((default . *error*) (62 . 337))
     ((default . *error*) (56 . 338))
     ((default . -193))
     ((default . -185))
     ((default . -189))
     ((default . *error*) (50 . 339))
     ((default . -187))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (56 . 80) (58 . 2))
     ((default . -199))
     ((default . *error*) (50 . 341))
     ((default . -210))
     ((default . -196))
     ((default . *error*) (44 . 342))
     ((default . -205))
     ((default . -195))
     ((default . *error*) (62 . 343))
     ((default . *error*) (57 . 344))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (40 . 5) (45 . 4) (56 . 3) (58 . 2))
     ((default . *error*) (56 . 346))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . -190))
     ((default . *error*) (44 . 348))
     ((default . -211))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (56 . 80) (58 . 2))
     ((default . *error*) (50 . 350))
     ((default . -79))
     ((default . *error*) (57 . 351))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63) (57 . 353))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (56 . 80) (58 . 2))
     ((default . *error*) (50 . 355))
     ((default . -206))
     ((default . -78))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (56 . 63) (57 . 356))
     ((default . -207))
     ((default . *error*) (50 . 357))
     ((default . -212))
     ((default . -208))
     ((default . -213))
    ))

; *** Goto Table ***
(define goto-table
  '#(
     ((49 . 20)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 60)(1 . 61))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 66))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 72)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 73)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 74))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 75))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 76)(10 . 77))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 78))
     ((46 . 21)(45 . 22)(44 . 81)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 82))
     ((33 . 34)(31 . 83))
     ()
     ((14 . 84))
     ((14 . 87))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 102)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ((48 . 112))
     ()
     ()
     ()
     ()
     ()
     ((33 . 34)(31 . 115))
     ()
     ()
     ()
     ()
     ()
     ()
     ((14 . 131))
     ((14 . 132))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((50 . 139))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 140))
     ((47 . 141)(46 . 142)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ((33 . 34)(32 . 146)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 147))
     ((33 . 34)(32 . 148)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 147))
     ((33 . 34)(32 . 150)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 147)(20 . 151)(19 . 152))
     ((33 . 34)(32 . 153)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 147))
     ((33 . 34)(32 . 154)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 147))
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 159)(10 . 160))
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 162)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 163)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 73)(23 . 43))
     ()
     ()
     ()
     ((46 . 164)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((14 . 166))
     ((14 . 167))
     ((46 . 164)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 177))
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 178)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 179)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 180)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 181)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 182)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 183)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 184)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((33 . 34)(32 . 185)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 147))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 186)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 187)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 188)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 189)(28 . 190))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 191))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 192))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 193))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 164)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 164)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 204)(10 . 205))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 206)(4 . 207))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 208)(8 . 209))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 210))
     ()
     ((68 . 225)(65 . 226)(61 . 227)(58 . 228)(55 . 229)(54 . 230)(53 . 231)(52 . 232)(51 . 233)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 234)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 235))
     ()
     ((46 . 237)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 238))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 239)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((33 . 34)(32 . 240)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 147))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 242))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 242))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 140))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 242)(20 . 245)(19 . 152))
     ((19 . 248))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 242)(20 . 250)(19 . 152))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 242))
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 252))
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 253)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ((14 . 254))
     ((46 . 164)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 164)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 162)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 102)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 242))
     ()
     ()
     ()
     ()
     ((33 . 34)(31 . 115))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((69 . 268))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 270))
     ((62 . 272))
     ((33 . 34)(32 . 274)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 147))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((56 . 281)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 282))
     ()
     ((59 . 285))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 242))
     ()
     ()
     ()
     ()
     ((19 . 248))
     ()
     ()
     ()
     ()
     ((19 . 248))
     ()
     ()
     ()
     ((46 . 164)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 299))
     ()
     ((62 . 301))
     ()
     ((62 . 303))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 242))
     ((62 . 305))
     ()
     ()
     ()
     ()
     ()
     ((57 . 306)(55 . 307)(53 . 308)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 309))
     ()
     ()
     ()
     ((66 . 311))
     ((64 . 312)(63 . 313)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 314))
     ()
     ()
     ()
     ()
     ((62 . 315))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 317))
     ()
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 318)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ((62 . 321))
     ()
     ((55 . 323)(53 . 324)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 309))
     ()
     ()
     ()
     ()
     ((68 . 328)(67 . 329)(60 . 330)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 331)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((64 . 312)(63 . 332)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 314))
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 335))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 340)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 345))
     ()
     ((33 . 34)(32 . 347)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 147))
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 349)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ((33 . 34)(32 . 352)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 147))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 242))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 354)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 242))
     ()
     ()
     ()
     ()
     ()
    ))

; *** Reduction Table ***
(define reduction-table
  (vector
    '()
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (accept $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 1 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 1 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 2 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 3 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 3 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 3 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 4 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 4 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 5 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 5 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 6 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 6 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 7 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 7 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 8 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 8 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 9 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 9 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 10 goto-table ($1 $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 10 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 10 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 11 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 11 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 11 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 12 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 12 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 13 goto-table (apply make-predicate-formula (cons $1 $2)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 13 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table (make-atomic-formula $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 13 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 14 goto-table (quote ()))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 14 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 15 goto-table (apply $1 (cons -1 $2)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 15 goto-table (apply $1 (cons $2 $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 15 goto-table (apply $1 (cons $3 $4)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 15 goto-table (apply $1 (cons -1 $3)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 16 goto-table (apply $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 16 goto-table (apply $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 17 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 17 goto-table ($2 $4))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) $2 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 $2 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 18 goto-table (idpredconst-name-and-types-and-cterms-to-idpredconst $2 $3 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 18 goto-table (idpredconst-name-and-types-and-cterms-to-idpredconst $2 $3 (quote ())))))
    (lambda (stack sp goto-table)
      (let* (($7 (vector-ref stack (- sp 1)))
             ($6 (vector-ref stack (- sp 3)))
             ($5 (vector-ref stack (- sp 5)))
             ($4 (vector-ref stack (- sp 7)))
             ($3 (vector-ref stack (- sp 9)))
             ($2 (vector-ref stack (- sp 11)))
             ($1 (vector-ref stack (- sp 13))))
          (push stack (- sp 14) 19 goto-table (apply make-cterm (append $4 (list $6))))))
    (lambda (stack sp goto-table)
      (let* (($6 (vector-ref stack (- sp 1)))
             ($5 (vector-ref stack (- sp 3)))
             ($4 (vector-ref stack (- sp 5)))
             ($3 (vector-ref stack (- sp 7)))
             ($2 (vector-ref stack (- sp 9)))
             ($1 (vector-ref stack (- sp 11))))
          (push stack (- sp 12) 19 goto-table (make-cterm $5))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 20 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 20 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 21 goto-table (make-arity))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 21 goto-table (apply make-arity $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 22 goto-table (cons $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 22 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 23 goto-table (make-var (type-var-name-to-type $1) -1 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) $2 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var (type-var-name-to-type $1) $3 0 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) -1 0 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var (type-var-name-to-type $1) $3 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) -1 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 23 goto-table (make-var $1 -1 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 $2 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 $3 0 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 -1 0 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 $3 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 -1 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 -1 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 $4 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 23 goto-table (make-var $1 $5 0 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 -1 0 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 23 goto-table (make-var $1 $5 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 -1 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 24 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 24 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 25 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 25 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 26 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 26 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 27 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 27 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 27 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 27 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 28 goto-table (apply make-alg (cons (alg-form-to-name $1) (append (alg-form-to-types $1) (list $2)))))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 28 goto-table (make-alg $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 29 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 29 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 30 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 30 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table (make-tconst $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table (make-alg $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 31 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 32 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 32 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 33 goto-table (make-tvar -1 $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 33 goto-table (make-tvar $2 $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 34 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 34 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 34 goto-table ($1 $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 34 goto-table (apply mk-term-in-abst-form (append $2 (list $4))))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 34 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 35 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 35 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 36 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 36 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 37 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 37 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 38 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 38 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 39 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 39 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 40 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 40 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 41 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 41 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 42 goto-table (make-gen-application $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 42 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 43 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 43 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 44 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 44 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 45 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 45 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 46 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 46 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 46 goto-table (make-term-in-var-form $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 46 goto-table (make-numeric-term $1))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 46 goto-table ($2 (cons $3 $4)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table (make-term-in-const-form (let* ((tvars (const-to-tvars $2)) (subst (make-substitution tvars $3))) (const-substitute $2 subst #f))))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table (make-term-in-if-form (car $3) (cdr $3)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 47 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 47 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 48 goto-table (lambda (x y) (make-term-in-app-form (make-term-in-app-form (make-term-in-const-form (let* ((tvars (const-to-tvars $1)) (subst (make-substitution tvars $2))) (const-substitute $1 subst #f))) x) y)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 49 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-command-load $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-command-include $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-command-scheme $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 52 goto-table (mpc-start #f #f))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-start #t #t))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-start #t #f))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 52 goto-table (mpc-stop))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 53 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 53 goto-table (mpc-claim $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 54 goto-table (mpc-assume $1))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 55 goto-table (mpc-block-stop))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 56 goto-table (mpc-block-start $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 58 goto-table (mpc-declare-type $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 58 goto-table (mpc-declare-var $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 58 goto-table (mpc-declare-pred (apply make-arity $2) $4))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 58 goto-table (mpc-declare-pred (make-arity) $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 58 goto-table (mpc-declare-algebra (car $1) (cadr $1) (cddr $1) $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 58 goto-table (mpc-function))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 58 goto-table (mpc-function))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 59 goto-table (mpc-function-rules-start))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 60 goto-table (mpc-function-rules-stop))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 61 goto-table (mpc-declare-algebra-header $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 61 goto-table (mpc-declare-algebra-header $2 0))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 62 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 62 goto-table (cons $1 $2))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 63 goto-table (quote ()))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 63 goto-table (cons $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 64 goto-table (list $3 $1))))
    (lambda (stack sp goto-table)
      (let* (($7 (vector-ref stack (- sp 1)))
             ($6 (vector-ref stack (- sp 3)))
             ($5 (vector-ref stack (- sp 5)))
             ($4 (vector-ref stack (- sp 7)))
             ($3 (vector-ref stack (- sp 9)))
             ($2 (vector-ref stack (- sp 11)))
             ($1 (vector-ref stack (- sp 13))))
          (push stack (- sp 14) 65 goto-table (mpc-declare-function $4 $6 $2 1))))
    (lambda (stack sp goto-table)
      (let* (($8 (vector-ref stack (- sp 1)))
             ($7 (vector-ref stack (- sp 3)))
             ($6 (vector-ref stack (- sp 5)))
             ($5 (vector-ref stack (- sp 7)))
             ($4 (vector-ref stack (- sp 9)))
             ($3 (vector-ref stack (- sp 11)))
             ($2 (vector-ref stack (- sp 13)))
             ($1 (vector-ref stack (- sp 15))))
          (push stack (- sp 16) 65 goto-table (mpc-declare-function $5 $7 $3 0))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 66 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 66 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 67 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 67 goto-table (mpc-computation-rule $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 67 goto-table (mpc-rewrite-rule $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 68 goto-table (mpc-declare-syntax $2 (car $3) (cadr $3) (caddr $3) $4))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
  ))

; *** Parser Definition ***
(define parser
   (make-parser
    action-table
    goto-table
    reduction-table
    token-defs))

; *** Terminals Table ***

(define terminal-table
   `#(
   ()
   ()
   (("excl" 45 . ,(lambda (v k) (apply mk-excl (append v (list k))))))
   (("CONST" 79 . ,(list (quote const) "CONST" 0)))
   (("LOAD" 69)("=>" 23 . ,make-arrow))
   ()
   (("cterm" 37))
   (("SYNTAX" 78))
   ()
   ()
   (("lambda" 27 . ,(lambda (varlist kernel) (apply mk-term-in-abst-form (append varlist (list kernel))))))
   ()
   ()
   ()
   ()
   (("IMPOP" 79 . ,(list (quote imp-op) "IMPOP" 2)))
   ()
   ()
   (("END" 68)("^'" 52))
   ()
   ()
   ()
   ()
   ()
   (("ADDOP" 79 . ,(list (quote add-op) "ADDOP" 2)))
   ()
   (("{" 60))
   (("^'_" 53)("@@" 20 . ,make-star))
   (("}" 61))
   (("OROP" 79 . ,(list (quote or-op) "OROP" 2)))
   ()
   ()
   ()
   (("!" 43 . ,make-tensor))
   ()
   (("MPC" 64))
   ()
   (("CLASSIC" 66))
   (("SCHEME" 71)("&" 41 . ,make-and))
   (("'" 51))
   (("(" 56)("allnc" 45 . ,(lambda (v k) (apply mk-allnc (append v (list k))))))
   ((")" 57))
   (("MULOP" 79 . ,(list (quote mul-op) "MULOP" 2))("REWRITE" 77)("Total" 10 . ,(string-and-arity-to-predconst-parse-function "Total" (make-arity (make-tvar -1 "alpha")))))
   (("PAIROP" 79 . ,(list (quote pair-op) "PAIROP" 2)))
   (("," 49))
   (("atomic" 4 . ,"atomic"))
   (("TYPE" 72)("." 46)("left" 25 . ,make-term-in-lcomp-form))
   ()
   (("PROOF" 65))
   ()
   (("INTUITIONISTIC" 67))
   (("ex" 45 . ,(lambda (v k) (apply mk-ex (append v (list k))))))
   ()
   ()
   ()
   ()
   ()
   ()
   (("INCLUDE" 70))
   (("ANDOP" 79 . ,(list (quote and-op) "ANDOP" 2))("FUNCTION" 75)(";" 50))
   (("RELOP" 79 . ,(list (quote rel-op) "RELOP" 2))("PARTIAL" 76))
   (("if" 38)("=" 31 . ,(lambda (term1 term2) (let ((type1 (term-to-type term1)) (type2 (term-to-type term2))) (mk-term-in-app-form (make-term-in-const-form (finalg-to-=-const (if (equal? type1 type2) type1 (types-lub type1 type2)))) term1 term2)))))
   ()
   ()
   (("@" 35 . ,make-term-in-pair-form))
   (("Pvar" 8))
   (("POSTFIXOP" 79 . ,(list (quote postfix-op) "POSTFIXOP" 1))("ALGEBRA" 74)("existential" 4 . ,"existential")("STotal" 10 . ,(string-and-arity-to-predconst-parse-function "STotal" (make-arity (make-tvar -1 "alpha")))))
   ()
   ()
   (("E" 25 . ,(lambda (term) (make-term-in-app-form (make-term-in-const-form (finalg-to-e-const (term-to-type term))) term)))("bot" 7 . ,(cons (make-arity) "bot")))
   (("exnc" 45 . ,(lambda (v k) (apply mk-exnc (append v (list k)))))("Equal" 10 . ,(string-and-arity-to-predconst-parse-function "Equal" (make-arity (make-tvar -1 "alpha") (make-tvar -1 "alpha")))))
   (("Rec" 26 . ,(lambda (l) (make-term-in-const-form (apply type-info-to-rec-const l)))))
   ()
   ()
   (("^_" 54))
   ()
   ()
   (("'_" 55)("prop" 4 . ,"prop"))
   ()
   (("right" 25 . ,make-term-in-rcomp-form))
   ()
   ()
   ()
   ()
   (("PREFIXOP" 79 . ,(list (quote prefix-op) "PREFIXOP" 1)))
   ()
   (("->" 44 . ,make-imp))
   ()
   (("exca" 45 . ,(lambda (v k) (apply mk-exca (append v (list k)))))("all" 45 . ,(lambda (v k) (apply mk-all (append v (list k))))))
   ()
   (("nulltype" 4 . ,"nulltype"))
   (("[" 58))
   ()
   (("]" 59))
   (("^" 47))
   (("_" 48)("alpha" 3 . ,"alpha"))
   (("PRED" 73))
  ))

; *** Lexer Definition ***
(define lexer
   (make-lexer
    terminal-table
    token-nrs
))


; *** Shortcut Definition ***
(define (pf string)
   (parser (lexer (string-reader string)) myerror))


(define (parse-file filename)
  (let ((parse-port
    (lambda (port)
      (parser (lexer (port-reader filename port)) myerror))))
    (call-with-input-file filename parse-port)))


; *** Add-Token Definition ***
(define add-token
   (make-add-token
    terminal-table
    token-nrs
))

; *** Remove-Token Definition ***
(define remove-token
   (make-remove-token
    terminal-table
    token-nrs
))

; *** Is-Token? Definition ***
(define is-token?
   (make-is-token?
    terminal-table
    token-defs
))

; *** Display-Tokens Definition ***
(define (display-tokens)
   (lexer-info
    terminal-table
    token-nrs
))

